/*******************************************************************/
/*
*   CLIPTRV Header File.
*   Copyright (C) 1994 Consult Computers P/L
*   For CA-Clipper 5.2 by Computer Associates.
*/
/*******************************************************************/
/*
*   General Defines.
*/
#define DEFAULT                     -2

/*******************************************************************/
/*
*   Btrieve FILE flags.
*/
#define BFF_NONE                    0
#define BFF_VARIABLE                1
#define BFF_TRUNCATE                2
#define BFF_PREALLOCATE             4
#define BFF_COMPRESS                8
#define BFF_KEYONLY                 16
#define BFF_NOTUSED                 32
#define BFF_THRESHOLD10             64
#define BFF_THRESHOLD20             128
#define BFF_THRESHOLD30             192

/*******************************************************************/
/*
*   Btrieve KEY flags.
*/
#define BKF_NONE                    0
#define BKF_DUPLICATES              1
#define BKF_MODIFIABLE              2
#define BKF_NOTUSED                 4
#define BKF_NULLVALUE               8
#define BKF_SEGMENTED               16
#define BKF_ALTERNATE               32
#define BKF_DESCENDING              64
#define BKF_SUPPLEMENTAL            128
#define BKF_EXTENDED                256
#define BKF_MANUAL                  512

#define BKF_BINARYKEY               260

/*******************************************************************/
/*
*   Btrieve DATA types.
*/
#define BDT_ZSTRING                 0
#define BDT_STRING                  1
#define BDT_LSTRING                 2
#define BDT_DATE                    3
#define BDT_LOGICAL                 4
#define BDT_INTEGER                 5
#define BDT_FLOAT                   6
#define BDT_LONG                    7
#define BDT_DOUBLE                  8
#define BDT_BFLOAT                  9
#define BDT_DECIMAL                 10
#define BDT_MONEY                   10
#define BDT_NUMERIC                 11

/*******************************************************************/
/*
*   Btrieve KEY types.
*/
#define BKT_STRING                  0
#define BKT_INTEGER                 1
#define BKT_FLOAT                   2
#define BKT_DATE                    3
#define BKT_TIME                    4
#define BKT_DECIMAL                 5
#define BKT_MONEY                   6
#define BKT_LOGICAL                 7
#define BKT_NUMERIC                 8
#define BKT_BFLOAT                  9
#define BKT_LSTRING                 10
#define BKT_ZSTRING                 11

#define BKT_UBINARY                 14
#define BKT_AUTOINC                 15

#define BKT_UNSIGNEDBINARY          14
#define BKT_AUTOINCREMENT           15
/*******************************************************************/
/*
*   Btrieve operation definitions.
*/

#define B_OPEN                      0
#define B_CLOSE                     1
#define B_INSERT                    2
#define B_UPDATE                    3
#define B_DELETE                    4
#define B_GET_EQ                    5
#define B_GET_NEXT                  6
#define B_GET_PREV                  7
#define B_GET_GT                    8
#define B_GET_GE                    9
#define B_GET_LT                    10
#define B_GET_LE                    11
#define B_GET_FIRST                 12
#define B_GET_LAST                  13
#define B_CREATE                    14
#define B_STATUS                    15
#define B_EXTEND                    16
#define B_SET_DIR                   17
#define B_GET_DIR                   18
#define B_BEGIN                     19
#define B_END                       20
#define B_ABORT                     21
#define B_GET_POS                   22
#define B_GET_DIRECT                23
#define B_STEP_NEXT                 24
#define B_STOP                      25
#define B_VERSION                   26
#define B_UNLOCK                    27
#define B_RESET                     28
#define B_SET_OWNER                 29
#define B_CLEAR_OWNER               30
#define B_MAKE_INDEX                31
#define B_DROP_INDEX                32
#define B_STEP_FIRST                33
#define B_STEP_LAST                 34
#define B_STEP_PREV                 35
#define B_GET_NEXT_EXT              36
#define B_GET_PREV_EXT              37
#define B_STEP_NEXT_EXT             38
#define B_STEP_PREV_EXT             39
#define B_INSERT_EXT                40

#define B_GET_BY_PERCENTAGE         44
#define B_FIND_PERCENTAGE           45

#define B_REFRESH                   101
#define B_SKIP                      102
#define B_GO_BOTTOM                 103
#define B_GO_TOP                    104
#define B_RECORD_COUNT              105
#define B_SET_INDEX                 106
#define B_INDEX_COUNT               107

/*******************************************************************/
/*
*   Btrieve status codes.
*/
#define BSC_INVALID                 1
#define BSC_IO_ERROR                2
#define BSC_FILE_NOT_OPEN           3
#define BSC_KEY_NOT_FOUND           4
#define BSC_DUPLICATE_KEY           5
#define BSC_INVALID_KEY             6
#define BSC_DIFFERENT_KEY           7
#define BSC_INVALID_POS             8
#define BSC_EOF                     9
#define BSC_MODIFY_KEY              10
#define BSC_INVALID_FILENAME        11
#define BSC_FILE_NOT_FOUND          12

#define BSC_CONFLICT                80

/*******************************************************************/

