/*******************************************************************/
#include "bfm.ch"
/*
*   Btrieve File Manager
*   Copyright (c) Consult Computers P/L
*   All Rights Reserved, 1995.
*
*   Bfm File Module.
*
*/
/*******************************************************************/

STATIC  smBfmName
STATIC  smBtrName
STATIC  smBtrFlags
STATIC  smFixedLen
STATIC  smMaxLen
STATIC  smPageSize
STATIC  smFields
STATIC  smIndexes

/*******************************************************************/

PROCEDURE   M_BfmFile( nTime )

    LOCAL   GetList := {}
    LOCAL   nCursor := SetCursor( SC_NORMAL )
    LOCAL   nTop := 8
    LOCAL   nLeft := 5
    LOCAL   nBottom := 15
    LOCAL   nRight := 72
    LOCAL   nHeight := nBottom - nTop + 1
    LOCAL   nWidth := nRight - nLeft + 1
    LOCAL   aScreen
    LOCAL   x


    /*
    *   Draw the border.
    */

    aScreen := MenuBox( "BFM File Information", nTop-3, nLeft-3, nHeight, nWidth )

    /*
    *   Clear the box.
    */

    FOR x := 0 TO nHeight-1
        SetPos( nTop+x, nLeft )
        DispOut( Replicate(" ", nWidth), Pub(PUB_CLR_BOX_INNER) )
    NEXT

    /*
    *   Setup help.
    */

    HelpLine( "ESC To Abort Edit" )

    /*
    *   Init?
    */

    IF ( nTime == 0 )

        smBfmName  := Space(129)
        smBtrName  := Space(129)
        smBtrFlags := Space(129)
        smFixedLen := 0
        smMaxLen   := 0
        smPageSize := 0
        smFields   := 0
        smIndexes  := 0

    ENDIF

    /*
    *   Edit fields.
    */

    @ nTop+0, nLeft+1 SAY "BFM Filename  :" COLOR Pub( PUB_CLR_BOX_INNER )  ;
                                            GET smBfmName                   ;
                                            PICT "@S50"                     ;
                                            COLOR Pub( PUB_CLR_BOX_EDIT )
    @ nTop+1, nLeft+1 SAY "Btrieve File  :" COLOR Pub( PUB_CLR_BOX_INNER )  ;
                                            GET smBtrName                  ;
                                            PICT "@S50"                     ;
                                            COLOR Pub( PUB_CLR_BOX_EDIT )
    @ nTop+2, nLeft+1 SAY "File Flags    :" COLOR Pub( PUB_CLR_BOX_INNER )  ;
                                            GET smBtrFlags                  ;
                                            WHEN BtrFlags()                 ;
                                            PICT "@S50"                     ;
                                            COLOR Pub( PUB_CLR_BOX_EDIT )
    @ nTop+3, nLeft+1 SAY "Fixed Length  :" COLOR Pub( PUB_CLR_BOX_INNER )  ;
                                            GET smFixedLen                  ;
                                            PICT "999999"                   ;
                                            COLOR Pub( PUB_CLR_BOX_EDIT )
    @ nTop+4, nLeft+1 SAY "Maximum Length:" COLOR Pub( PUB_CLR_BOX_INNER )  ;
                                            GET smMaxLen                    ;
                                            PICT "999999"                   ;
                                            COLOR Pub( PUB_CLR_BOX_EDIT )
    @ nTop+5, nLeft+1 SAY "Page Size     :" COLOR Pub( PUB_CLR_BOX_INNER )  ;
                                            GET smPageSize                  ;
                                            WHEN PageSize()                 ;
                                            PICT "999999"                   ;
                                            COLOR Pub( PUB_CLR_BOX_EDIT )
    @ nTop+6, nLeft+1 SAY "Field Count   :" COLOR Pub( PUB_CLR_BOX_INNER )  ;
                                            GET smFields                    ;
                                            PICT "999999"                   ;
                                            COLOR Pub( PUB_CLR_BOX_EDIT )
    @ nTop+7, nLeft+1 SAY "Index Count   :" COLOR Pub( PUB_CLR_BOX_INNER )  ;
                                            GET smIndexes                   ;
                                            PICT "999999"                   ;
                                            COLOR Pub( PUB_CLR_BOX_EDIT )

    READ

    /*
    *   Restore cursor.
    */

    SetCursor( nCursor )

    /*
    *   Restore help.
    */

    HelpLine()

    /*
    *   Restore the screen.
    */

    RestScreen( aScreen[1], aScreen[2], aScreen[3], aScreen[4], aScreen[5] )

RETURN

/*******************************************************************/

STATIC FUNCTION     BtrFlags()

    LOCAL   nLastKey := LastKey()


    /*
    *   Display a menu of file flags.
    */

    Menu( 7, 43, "File Flags", "Select an Option, ESC To Abort", 1, 10, ;
        { { "BFF_VARIABLE   ", {|| TRUE} , {|n| M_Flag(n)} } , ;
          { "BFF_TRUNCATE   ", {|| TRUE} , {|n| M_Flag(n)} } , ;
          { "BFF_PREALLOCATE", {|| TRUE} , {|n| M_Flag(n)} } , ;
          { "BFF_COMPRESS   ", {|| TRUE} , {|n| M_Flag(n)} } , ;
          { "BFF_KEYONLY    ", {|| TRUE} , {|n| M_Flag(n)} } , ;
          { "BFF_THRESHOLD10", {|| TRUE} , {|n| M_Flag(n)} } , ;
          { "BFF_THRESHOLD20", {|| TRUE} , {|n| M_Flag(n)} } , ;
          { "BFF_THRESHOLD30", {|| TRUE} , {|n| M_Flag(n)} } } )

    /*
    *   Force out of this get.
    */

    KEYBOARD Chr(nLastKey)

RETURN  TRUE

/*******************************************************************/

STATIC PROCEDURE    M_Flag( nType )

    /*
    *   Store the chosen data type.
    */

    IF ( Empty( smBtrFlags ) )

        smBtrFlags := AllTrim(BtrvFFName( nType-1 ))

    ELSE

        smBtrFlags += "+" + AllTrim(BtrvFFName( nType-1 ))

    ENDIF

    /*
    *   Break out of menu.
    */

    KEYBOARD Chr(K_ESC)

RETURN

/*******************************************************************/

STATIC FUNCTION     PageSize()

    LOCAL   nLastKey := LastKey()


    /*
    *   Display a menu of available page sizes.
    */

    Menu( 7, 43, "Page Sizes", "Select an Option, ESC To Abort", 2, 10, ;
        { { "512        ", {|| TRUE} , {|n| M_Page(n)} } , ;
          { "1024       ", {|| TRUE} , {|n| M_Page(n)} } , ;
          { "1536       ", {|| TRUE} , {|n| M_Page(n)} } , ;
          { "2048       ", {|| TRUE} , {|n| M_Page(n)} } , ;
          { "2560       ", {|| TRUE} , {|n| M_Page(n)} } , ;
          { "3072       ", {|| TRUE} , {|n| M_Page(n)} } , ;
          { "3584       ", {|| TRUE} , {|n| M_Page(n)} } , ;
          { "4096       ", {|| TRUE} , {|n| M_Page(n)} } } )

    /*
    *   Force out of this get.
    */

    KEYBOARD Chr(nLastKey)

RETURN  TRUE

/*******************************************************************/

STATIC PROCEDURE    M_Page( nPos )

    /*
    *   Store the chosen data type.
    */

    smpageSize := nPos * 512

    /*
    *   Break out of menu.
    */

    KEYBOARD Chr(K_ESC)

RETURN

/*******************************************************************/

FUNCTION    BfmFileChk()

    IF ( Empty( smBfmName ) )

        RETURN  FALSE

    ELSEIF ( Empty( smBtrName ) )

        RETURN  FALSE

    ELSEIF ( Empty( smFixedLen ) )

        RETURN  FALSE

    ELSEIF ( Empty( smMaxLen ) )

        RETURN  FALSE

    ELSEIF ( Empty( smPageSize ) )

        RETURN  FALSE

    ELSEIF ( Empty( smFields ) )

        RETURN  FALSE

    ELSEIF ( Empty( smIndexes ) )

        RETURN  FALSE

    ENDIF

RETURN  TRUE

/*******************************************************************/

FUNCTION    BfmFileName()

RETURN  AllTrim(smBfmName)

/*******************************************************************/

FUNCTION    BfmFileExec( h )

    /*
    *   Write out the file information.
    */

    FwriteLine( h, "[File]" )

    FwriteStr ( h, "fileName    =   " )
    FwriteLine( h, AllTrim(smBtrName) )

    FwriteStr ( h, "fixedLen    =   " )
    FwriteLine( h, AllTrim(Str(smFixedLen)) )

    FwriteStr ( h, "maxRecLen   =   " )
    FwriteLine( h, AllTrim(Str(smMaxLen)) )

    FwriteStr ( h, "pageSize    =   " )
    FwriteLine( h, AllTrim(Str(smPageSize)) )

    FwriteStr ( h, "flags       =   " )
    FwriteLine( h, AllTrim(smBtrFlags) )

    FwriteStr ( h, "fields      =   " )
    FwriteLine( h, AllTrim(Str(smFields)) )

    FwriteStr ( h, "indexes     =   " )
    FwriteLine( h, AllTrim(Str(smIndexes)) )

    FwriteLine( h, "" )
    FwriteLine( h, "" )

RETURN  TRUE

/*******************************************************************/

PROCEDURE   M_FilUpdate( cBfm, cBtr, nFixed, nPage, nMax, cFlags, nFields, nIndexes )

    /*
    *   Update the variables.
    */

    smBfmName  := cBfm + Space( 129 - Len( cBfm ) )
    smBtrName  := cBtr + Space( 129 - Len( cBtr ) )
    smBtrFlags := cFlags
    smFixedLen := nFixed
    smMaxLen   := nMax
    smPageSize := nPage
    smFields   := nFields
    smIndexes  := nIndexes

RETURN

/*******************************************************************/

