/*******************************************************************/
#include "bfm.ch"
/*
*   Btrieve File Manager
*   Copyright (c) Consult Computers P/L
*   All Rights Reserved, 1995.
*
*   Bfm Fields Module.
*
*/
/*******************************************************************/

STATIC  soBrowse
STATIC  slAppend, slKillAppend
STATIC  saField
STATIC  snFields := 0
STATIC  saFields
STATIC  snFldPtr := 1
STATIC  slMore

/*******************************************************************/

PROCEDURE   M_BfmField( nTime )

    LOCAL   nTop := 9
    LOCAL   nLeft := 5
    LOCAL   nBottom := 20
    LOCAL   nRight := 70
    LOCAL   nHeight := nBottom - nTop + 1
    LOCAL   nWidth := nRight - nLeft + 1
    LOCAL   aScreen
    LOCAL   x
    LOCAL   oColumn
    LOCAL   keystroke
    LOCAL   lGotKey



    /*
    *   Check
    */

    IF ( nTime == 0 )

        snFields := 0
        saFields := {}

    ENDIF

    /*
    *   Init the array to hold the new record.
    */

    InitBlank()

    /*
    *   Always default to first record.
    */

    snFldPtr := 1

    /*
    *   Create the Tbrowse Object.
    */

    soBrowse := TBrowseNew( nTop, nLeft, nBottom, nRight )

    /*
    *   Setup browse.
    */

    soBrowse:headSep := ""
    soBrowse:colSep  := "  "
//  soBrowse:footSep := ""

    soBrowse:skipBlock := {|s| Skipped(s)}
    soBrowse:goTopBlock := {|| snFldPtr := 1}
    soBrowse:goBottomBlock := {|| snFldPtr := snFields}

    soBrowse:colorSpec := Pub( PUB_CLR_BOX_INNER ) + "," +;
                         Pub( PUB_CLR_BOX_MENUBAR )

    /*
    *   Add the columns to the browse.
    */

    oColumn := TBColumnNew( "NAME", {|| GetData(1)} )
    oColumn:width := 20
    soBrowse:addColumn( oColumn )

    oColumn := TBColumnNew( "TYPE", {|| GetData(2)} )
    oColumn:width := 11
    soBrowse:addColumn( oColumn )

    oColumn := TBColumnNew( "LEN", {|| GetData(3)} )
    oColumn:width := 5
    soBrowse:addColumn( oColumn )

    oColumn := TBColumnNew( "DEC", {|| GetData(4)} )
    oColumn:width := 5
    soBrowse:addColumn( oColumn )

    oColumn := TBColumnNew( "POS", {|| GetData(5)} )
    oColumn:width := 5
    soBrowse:addColumn( oColumn )


    /*
    *   Draw the border.
    */

    aScreen := MenuBox( "Btrieve File Fields", nTop-3, nLeft-3, nHeight, nWidth )

    /*
    *   Setup Help
    */

    HelpLine( "ENTER To Edit, DEL To Delete, ESC For BFM Menu" )

    /*
    *   Initialisation
    */

    slAppend := FALSE
    slKillAppend := FALSE
    keystroke := 0

    slMore := TRUE
    WHILE (slMore)

        /*
        *   Check for killing the append.
        */

        IF ( slKillAppend )

            /*
            *   Ask user if they want to save the new record.
            */

            Menu( 7, 27, "Save New Field?", "ESC To Cancel", 2, 10, ;
                { { "No       " , {|| TRUE} , {|| M_Save(FALSE) } } , ;
                  { "Yes      " , {|| TRUE} , {|| M_Save(TRUE)  } } , ;
                  { "Cancel   " , {|| TRUE} , {|| M_Escape()    } } } )

            /*
            *   Reset flag.
            */

            slKillAppend := FALSE

            /*
            *   Check
            */

            IF ( ! slAppend )

                /*
                *   Restore the help.
                */

                HelpLine()

                /*
                *   If we have no records, outa here!
                */

                IF ( snFields == 0 )

                    EXIT

                ENDIF

            ENDIF

        ENDIF

        /*
        *   Check for an empty file.
        */

        IF ( snFields == 0  .AND.  ! slAppend )

            /*
            *   Go into append mode.
            */

            KEYBOARD Chr(K_DOWN)

        ENDIF

        /*
        *   Keystroke will interrupt stabilize
        */

        lGotKey := FALSE

        WHILE ( !soBrowse:stabilize() )

            IF ( (keystroke := Inkey()) != 0 )

                lGotKey := TRUE
                EXIT

            ENDIF

        ENDDO

        /*
        *   Check last keypress.
        */

        IF ( ! slAppend .AND. keystroke == K_DOWN .AND. soBrowse:hitBottom )

            /*
            *   Go into append mode.
            */

            slAppend := TRUE
            InitBlank()

            IF ( snFields > 0 )

                soBrowse:down()
                lGotKey := TRUE

            ENDIF

            /*
            *   Setup Help
            */

            HelpLine( "Editing New Record, ESC For Save Options" )

        ENDIF

        /*
        *   Wait for a key if all is well...
        */

        IF ( ! lGotKey )

            keystroke := Inkey(0)

        ENDIF

        /*
        *   The monster case statement...
        */

        DO CASE

        CASE keystroke == K_ESC

            IF ( slAppend )

                slKillAppend := TRUE

            ELSE

                EXIT

            ENDIF

        CASE keystroke == K_ENTER

            EditCell( 0 )

        CASE keystroke == K_DOWN

            IF ( ! slAppend )

                soBrowse:down()

            ENDIF

        CASE keystroke == K_UP

            IF ( slAppend )

                slKillAppend := TRUE

            ELSE

                soBrowse:up()

            ENDIF

        CASE keystroke == K_PGDN

            IF ( ! slAppend )

                soBrowse:pageDown()

            ENDIF

        CASE keystroke == K_PGUP

            IF ( slAppend )

                slKillAppend := TRUE

            ELSE

                soBrowse:pageUp()

            ENDIF

        CASE keystroke == K_CTRL_PGUP

            IF ( slAppend )

                slKillAppend := TRUE

            ELSE

                soBrowse:goTop()

            ENDIF

        CASE keystroke == K_CTRL_PGDN

            IF ( ! slAppend )

                soBrowse:goBottom()

            ENDIF

        CASE keystroke == K_RIGHT

            soBrowse:right()

        CASE keystroke == K_LEFT

            soBrowse:left()

        CASE keystroke == K_HOME

            soBrowse:home()

        CASE keystroke == K_END

            soBrowse:end()

        CASE keystroke == K_CTRL_LEFT

            soBrowse:panLeft()

        CASE keystroke == K_CTRL_RIGHT

            soBrowse:panRight()

        CASE keystroke == K_CTRL_HOME

            soBrowse:panHome()

        CASE keystroke == K_CTRL_END

            soBrowse:panEnd()

        CASE keystroke == K_DEL

            IF ( ! slAppend )

                /*
                *   Ask user if the want to delete the column or record.
                */

                Menu( 7, 27, "Delete", "ESC To Cancel", 1, 10, ;
                    { { "Column Field " , {|| TRUE} , {|| M_Delete(TRUE)  } } , ;
                      { "Entire Record" , {|| TRUE} , {|| M_Delete(FALSE) } } , ;
                      { "Cancel       " , {|| TRUE} , {|| M_Escape()    } } } )

            ENDIF

        OTHERWISE


            /*
            *   Is this a valid edit keystroke?
            */

            IF ( keystroke >= K_SPACE  .AND.  keystroke <= Asc( "z" ) )

                EditCell( keystroke )

            ENDIF

        ENDCASE

    ENDDO

    /*
    *   Restore the screen.
    */

    RestScreen( aScreen[1], aScreen[2], aScreen[3], aScreen[4], aScreen[5] )

    /*
    *   Restore help.
    */

    HelpLine()

RETURN

/*******************************************************************/

STATIC FUNCTION     Skipped( nRequest )

    LOCAL   nCount := 0


    /*
    *   Special case for appending a record.
    */

    IF ( slAppend )

        /*
        *   Ask me no questions, I'll tell you no lies...
        */

        RETURN  nRequest

    ENDIF


    /*
    *   Standard procedure...
    */

    IF ( snFields > 0 )

        IF ( nRequest == 0 )

            /*
            *   Do nothing
            */

        ELSEIF ( nRequest > 0 )

            /*
            *   Forward
            */

            WHILE ( nCount < nRequest )

                IF ( snFldPtr == snFields )

                    EXIT

                ELSE

                    snFldPtr++

                ENDIF

				nCount++

            ENDDO

        ELSEIF ( nRequest < 0 )

            /*
            *   Backward
            */

            WHILE ( nCount > nRequest )

                IF ( snFldPtr == 1 )

                    EXIT

                ELSE

                    snFldPtr--

                ENDIF

				nCount--

            ENDDO

        ENDIF

    ENDIF

RETURN  nCount

/*******************************************************************/

STATIC FUNCTION     GetData( nPos )

    /*
    *   Check if we are appending.
    */

    IF ( slAppend  .OR.  snFields == 0 )

        RETURN  saField[ nPos ]

    ENDIF

RETURN  saFields[ snFldPtr, nPos ]

/*******************************************************************/

STATIC PROCEDURE    InitBlank()

    /*
    *   Initialise array used to hold new record information.
    */

    saField := { Space(20), Space(11), 0, 0, 0 }

RETURN

/*******************************************************************/

STATIC PROCEDURE    M_Save( lSave )


    IF ( lsave )

        /*
        *   Store the new record.
        */

        Aadd( saFields, saField )

        /*
        *   Increment record count.
        */

        snFields++

    ENDIF

    /*
    *   Reset the flags.
    */

    slAppend := FALSE

    /*
    *   Close the menu.
    */

    KEYBOARD Chr(K_ESC)

    /*
    *   Refresh the browse.
    */

    soBrowse:refreshAll()

RETURN

/*******************************************************************/

STATIC PROCEDURE    EditCell( nKey )

    LOCAL   nPos := soBrowse:colPos
    LOCAL   oColumn := soBrowse:getColumn(nPos)
    LOCAL   mVar := Eval(oColumn:block)
    LOCAL   nCursor := SetCursor( SC_NORMAL )
    LOCAL   GetList := {}
    LOCAL   nRow := Row(), nCol := Col()
    LOCAL   cPicture := ""


    /*
    *   Setup Help
    */

    HelpLine( "ENTER To Save Edit, ESC To Abort" )

    /*
    *   Can we edit this cell?
    */

    IF ( nPos != 2 )    //  All but the field type.

        IF ( ValType(mVar) == "N" )

            cPicture := "99999"

        ENDIF

        IF ( nKey > 0 )
            KEYBOARD Chr(nKey)
        ENDIF

        @ nRow, nCol GET mVar COLOR Pub( PUB_CLR_CELL_EDIT ) PICT cPicture
        READ

        /*
        *   Do we save to the array?
        */

        IF ( LastKey() != K_ESC )

            IF ( slAppend )

                /*
                *   This is a new field.
                *   Just update the array for now.
                */

                saField[ nPos ] := mVar

            ELSE

                /*
                *   This is a record field.
                *   Update the record element.
                */

                saFields[ snFldPtr, nPos ] := mVar

            ENDIF

        ENDIF

    ELSE

        /*
        *   With the field type we give 'em a menu.
        */

        Menu( 7, 43, "Field Types", "Select an Option, ESC To Abort", 1, 10, ;
            { { "BDT_ZSTRING", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_STRING ", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_LSTRING", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_DATE   ", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_LOGICAL", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_INTEGER", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_FLOAT  ", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_LONG   ", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_DOUBLE ", {|| TRUE} , {|n| M_Field(n)} } , ;
              { "BDT_BFLOAT ", {|| TRUE} , {|n| M_Field(n)  } } } )

    ENDIF

    /*
    *   Restore cursor.
    */

    SetCursor( nCursor )

    /*
    *   Restore help.
    */

    HelpLine()

    /*
    *   Refresh the browse.
    */

    soBrowse:refreshCurrent()

RETURN

/*******************************************************************/

STATIC PROCEDURE    M_Field( nType )

    /*
    *   Store the chosen data type.
    */

    IF ( slAppend )

        saField[ 2 ] := BtrvDName( nType-1 )

    ELSE

        saFields[ snFldPtr, 2 ] := BtrvDName( nType-1 )

    ENDIF

    /*
    *   Break out of menu.
    */

    KEYBOARD Chr(K_ESC)

RETURN

/*******************************************************************/

FUNCTION    BfmFieldChk()

    IF ( snFields == 0 )

        RETURN  FALSE

    ENDIF

RETURN  TRUE

/*******************************************************************/

STATIC PROCEDURE    M_Delete( lField )

    LOCAL   nPos := soBrowse:colpos


    /*
    *   Init the append array and use it to delete a field.
    */
    InitBlank()

    /*
    *   What do we delete?
    */

    IF ( lField )

        /*
        *   Wipe the column only.
        */

        saFields[ snFldPtr, nPos ] := saField[ nPos ]

    ELSE

        /*
        *   Remove the array record.
        */

        Adel( saFields, snFldPtr )
        snFields--
        Asize( saFields, snFields )

        /*
        *   Check the pointer.
        */

        IF ( snFldPtr > snFields )

            IF ( snFields > 0 )

                snFldPtr := snFields

            ELSE

                snFldPtr := 1

            ENDIF

        ENDIF

    ENDIF

    /*
    *   Refresh the browse.
    */

    soBrowse:refreshCurrent()

    /*
    *   Close the menu.
    */

    KEYBOARD Chr(K_ESC)

RETURN

/*******************************************************************/

FUNCTION    BfmFieldExec( h )

    LOCAL   x


    /*
    *   Heading.
    */

    Fwriteline( h, "[Fields]" )

    /*
    *   Write out the fields for the BFM.
    */

    FOR x := 1 TO snFields

        FwriteStr ( h, "fieldName   =   " )
        FwriteLine( h, AllTrim(saFields[x,1]) )

        FwriteStr ( h, "fieldType   =   " )
        FwriteLine( h, AllTrim(saFields[x,2]) )

        FwriteStr ( h, "fieldLen    =   " )
        FwriteLine( h, AllTrim(Str(saFields[x,3])) )

        FwriteStr ( h, "fieldDec    =   " )
        FwriteLine( h, AllTrim(Str(saFields[x,4])) )

        FwriteStr ( h, "fieldPos    =   " )
        FwriteLine( h, AllTrim(Str(saFields[x,5])) )

        FwriteLine( h, "" )

    NEXT

    /*
    *   Some space.
    */

    FwriteLine( h, "" )
    FwriteLine( h, "" )

RETURN  TRUE

/*******************************************************************/

PROCEDURE   M_FldUpdate( aArray )

    /*
    *   Clone the array.
    */

    saFields := Aclone( aArray )
    snFields := Len( saFields )

RETURN

/*******************************************************************/

