/*******************************************************************/
#include "bfm.ch"
/*
*   Btrieve File Manager
*   Copyright (c) Consult Computers P/L
*   All Rights Reserved, 1995.
*
*   Modify Module.
*
*/
/*******************************************************************/

PROCEDURE   M_Modify()

    LOCAL   cBfmName := SelectBfm( 10, 36, Pub( PUB_THE_DIR ) )
    LOCAL   h
    LOCAL   cLine
    LOCAL   cFileName, nFixedLen, nPageSize, nMaxLen, cFlags, nFields, nIndexes
    LOCAL   cKeyType, nKeyPos, nKeyLen, cKeyFlags
    LOCAL   cFieldname, cFieldType, nFieldLen, nFieldDec, nFieldPos
    LOCAL   aFields := {}
    LOCAL   aKeys := {}


    /*
    *   Check.
    */

    IF ( cBfmName == NIL )

        RETURN

    ENDIF

    /*
    *   Read in the Bfm file information to create a btrieve file.
    */

    IF ( ( h := Fopen( cBfmName, FC_NORMAL ) ) > 0 )

        /*
        *   Extract the BFM information.
        */

        cLine := FileLine( h, "fileName", FALSE )
        cFileName := AllTrim(Token( cLine, EQUAL, 2 ))

        cLine := FileLine( h, "fixedLen", FALSE )
        nFixedLen := Val(AllTrim(Token( cLine, EQUAL, 2 )))

        cLine := FileLine( h, "maxRecLen", FALSE )
        nMaxLen := Val(AllTrim(Token( cLine, EQUAL, 2 )))

        cLine := FileLine( h, "pageSize", FALSE )
        nPageSize := Val(AllTrim(Token( cLine, EQUAL, 2 )))

        cLine := FileLine( h, "flags", FALSE )
        cFlags := AllTrim(Token( cLine, EQUAL, 2 ))

        cLine := FileLine( h, "fields", FALSE )
        nFields := Val(AllTrim(Token( cLine, EQUAL, 2 )))

        cLine := FileLine( h, "indexes", FALSE )
        nIndexes := Val(AllTrim(Token( cLine, EQUAL, 2 )))

        /*
        *   Read in the fields.
        */

        WHILE ( TRUE )

            /*
            *   Check if we can find a fieldname token.
            */

            IF ( ( cLine := FileLine( h, "fieldName", FALSE ) ) == NIL )

                EXIT

            ELSE

                cFieldName := AllTrim(Token( cLine, EQUAL, 2 ))
                cFieldName += Space( 20 - Len( cFieldName ) )

            ENDIF

            /*
            *   Process the rest of the field information.
            */

            cLine := FileLine( h, "fieldType", FALSE )
            cFieldType := AllTrim(Token( cLine, EQUAL, 2 ) )

            cLine := FileLine( h, "fieldLen", FALSE )
            nFieldLen  := Val( Token( cLine, EQUAL, 2 ) )

            cLine := FileLine( h, "fieldDec", FALSE )
            nFieldDec  := Val( Token( cLine, EQUAL, 2 ) )

            cLine := FileLine( h, "fieldPos", FALSE )
            nFieldPos  := Val( Token( cLine, EQUAL, 2 ) )

            Aadd( aFields, { cFieldname, cFieldType, nFieldLen, nFieldDec, nFieldPos } )

        ENDDO

        /*
        *   Read in the indexes.
        */

        Fseek( h, 0, FS_SET )   //  NOTE:

        WHILE ( TRUE )

            /*
            *   Check if we can find a fieldname token.
            */

            IF ( ( cLine := FileLine( h, "keyType", FALSE ) ) == NIL )

                EXIT

            ELSE

                cKeyType := AllTrim(Token( cLine, EQUAL, 2 ))

            ENDIF

            /*
            *   Process the rest of the index information.
            */

            cLine := FileLine( h, "keyPos", FALSE )
            nKeyPos := Val( Token( cLine, EQUAL, 2 ) )

            cLine := FileLine( h, "keyLen", FALSE )
            nKeyLen  := Val( Token( cLine, EQUAL, 2 ) )

            cLine := FileLine( h, "keyFlags", FALSE )
            cKeyFlags  := AllTrim(Token( cLine, EQUAL, 2 ))

            /*
            *   Add to the key array.
            */

            Aadd( aKeys, { cKeyType, nKeyPos, nKeyLen, cKeyFlags } )

        ENDDO

        /*
        *   Close the BFM file.
        */

        Fclose( h )


        /*
        *   Now call the routines that will update the file, field, index
        *   information.
        */

        M_FilUpdate( cBfmName, cFileName, nFixedLen, nPageSize, nMaxLen, ;
                     cFlags, nFields, nIndexes )
        M_FldUpdate( aFields )
        M_IdxUpdate( aKeys )

        /*
        *   Now allow editing of the BFM information.
        */

        M_OldBfm()

    ELSE

        Msg( 14, 22, cBfmName, "Failed To Open File." )

    ENDIF

RETURN

/*******************************************************************/

